<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../../common/content-types';
import { getClient } from '~/plugins/contentful.js';
import {
  CaseStudyContentArea,
  CaseStudyCustomerSuccessStories,
  CaseStudyHero,
  CaseStudyPricingPlans,
  CaseStudyStickySidebar,
} from '~/components/customers/index.vue';
import { NextStepAlt } from '~/components/common/index.vue';

import { getPageMetadata } from '~/common/meta';
import { AvailableLanguagesMixin, LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { FooterEditLinkMixin } from '~/mixins';
import {
  convertToCaseSensitiveLocale,
  getAvailableLanguagesFromTags,
} from '~/common/util';

export default Vue.extend({
  components: {
    CaseStudyContentArea,
    CaseStudyHero,
    CaseStudyPricingPlans,
    CaseStudyStickySidebar,
    CaseStudyCustomerSuccessStories,
    NextStepAlt,
  },
  mixins: [FooterEditLinkMixin, LivePreviewMixin, AvailableLanguagesMixin],
  // The middleware fetch the data once and saves it in the context to be used in the following lifecycle methods (validate, asyncData)
  async middleware(context) {
    if (process.client) {
      return;
    }

    const locale = convertToCaseSensitiveLocale(context.i18n.locale);
    const { items } = await getClient().getEntries({
      content_type: CONTENT_TYPES.CASE_STUDY,
      'fields.slug': context.params.slug,
      include: 3,
      locale,
    });

    const [page] = items;

    context.$pageData = page;
    if (page) {
      context.$availableLanguages = getAvailableLanguagesFromTags(
        page.metadata.tags,
      );
    }
  },
  async asyncData({ i18n, $content, $pageData, $availableLanguages }: any) {
    const { fields, sys } = $pageData;
    const spaceId = sys.space.sys.id;
    const entryId = sys.id;

    const baseData = await $content(
      `shared/${i18n.locale}/customers/base-template`,
    ).fetch();

    const metadata = {
      title: fields.seoMetadata?.fields.ogTitle ?? fields.companyName,
      description:
        fields.seoMetadata?.fields.ogDescription ?? fields.introduction,
      og_title: fields.seoMetadata?.fields.ogTitle ?? fields.companyName,
      og_image:
        fields.seoMetadata?.fields?.ogImage?.fields.image?.fields.file.url ??
        fields.headerImage.fields.file.url,
      og_description:
        fields.seoMetadata?.fields.ogDescription ?? fields.introduction,
      twitter_image:
        fields.seoMetadata?.fields?.ogImage?.fields.image?.fields.file.url ??
        fields.headerImage.fields.file.url,
      twitter_description:
        fields.seoMetadata?.fields.ogDescription ?? fields.introduction,
    };

    return {
      fields,
      baseData,
      metadata,
      spaceId,
      entryId,
      availableLanguages: $availableLanguages,
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
      this.availableLanguages,
    );
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.data,
        callback: (updatedData) => (this.data = updatedData),
      });

      const baseDataFn = ContentfulLivePreview.subscribe({
        data: this.baseData,
        callback: (updatedData) => (this.baseData = updatedData),
      });

      this.livePreviewSubscriptions.push(unsubscribeFn);
      this.livePreviewSubscriptions.push(baseDataFn);
    }
  },
});
</script>

<template>
  <div>
    <CaseStudyHero :data="fields" :base-data="baseData" />

    <section>
      <SlpContainer class="slp-flex">
        <CaseStudyStickySidebar :data="fields" :base-data="baseData" />
        <CaseStudyContentArea :data="fields" :base-data="baseData" />
      </SlpContainer>
    </section>

    <CaseStudyPricingPlans :base-data="baseData" />

    <CaseStudyCustomerSuccessStories :base-data="baseData" />

    <section class="slp-mt-96">
      <NextStepAlt />
    </section>
  </div>
</template>
